Linux cpanel2.daytoncreative.net 2.6.32-754.29.2.el6.x86_64 #1 SMP Tue May 12 17:39:04 UTC 2020 x86_64
Apache/2.4.43 (cPanel) OpenSSL/1.1.1g mod_bwlimited/1.4
Server IP : 70.62.220.67 & Your IP : 216.73.216.193
Domains :
Cant Read [ /etc/named.conf ]
User : michaelgreg
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
var /
log /
perl-5.20.2 /
Delete
Unzip
Name
Size
Permission
Date
Action
.config
[ DIR ]
drwxr-xr-x
2016-10-10 17:32
Cross
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
NetWare
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
Porting
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
cpan
[ DIR ]
drwxr-xr-x
2015-02-14 16:55
cygwin
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
dist
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
djgpp
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
ext
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
h2pl
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
haiku
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
hints
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
lib
[ DIR ]
drwxr-xr-x
2016-10-10 18:16
mad
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
os2
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
plan9
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
pod
[ DIR ]
drwxr-xr-x
2016-10-10 18:13
qnx
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
regen
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
symbian
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
t
[ DIR ]
drwxr-xr-x
2016-10-10 19:00
utils
[ DIR ]
drwxr-xr-x
2016-10-10 17:41
vms
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
vos
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
win32
[ DIR ]
drwxr-xr-x
2015-02-14 16:56
x2p
[ DIR ]
drwxr-xr-x
2016-10-10 17:41
AUTHORS
44.95
KB
-r--r--r--
2015-01-28 21:08
Artistic
6.17
KB
-r--r--r--
2014-12-27 11:48
Changes
3.09
KB
-r--r--r--
2014-12-27 11:48
Configure
539.85
KB
-r-xr-xr-x
2015-01-10 12:06
Copying
12.34
KB
-r--r--r--
2014-12-27 11:48
DynaLoader.o
9.58
KB
-rw-r--r--
2016-10-10 17:38
EXTERN.h
2.04
KB
-r--r--r--
2014-12-27 11:48
INSTALL
104.05
KB
-r--r--r--
2015-01-31 15:32
INTERN.h
1.47
KB
-r--r--r--
2014-12-27 11:49
MANIFEST
300.93
KB
-r--r--r--
2015-01-28 21:08
META.json
3.58
KB
-r--r--r--
2015-02-01 03:22
META.yml
2.83
KB
-r--r--r--
2015-01-28 21:08
Makefile
34.77
KB
-rw-r--r--
2016-10-10 17:34
Makefile.SH
48.39
KB
-r-xr-xr-x
2014-12-27 11:49
Makefile.micro
5.13
KB
-r--r--r--
2014-12-27 11:48
Policy.sh
5.33
KB
-rw-r--r--
2016-10-10 17:34
Policy_sh.SH
7.94
KB
-r-xr-xr-x
2014-12-27 11:48
README
5.53
KB
-r--r--r--
2015-01-28 21:11
README.aix
19.15
KB
-r--r--r--
2014-12-27 11:49
README.amiga
6.87
KB
-r--r--r--
2014-12-27 11:48
README.android
7.61
KB
-r--r--r--
2014-12-27 11:48
README.bs2000
7.73
KB
-r--r--r--
2014-12-27 11:48
README.ce
14.27
KB
-r--r--r--
2014-12-27 11:48
README.cn
4.58
KB
-r--r--r--
2014-12-27 11:48
README.cygwin
26.67
KB
-r--r--r--
2014-12-27 11:49
README.dos
10.28
KB
-r--r--r--
2014-12-27 11:48
README.freebsd
1.55
KB
-r--r--r--
2014-12-27 11:48
README.haiku
1.47
KB
-r--r--r--
2015-01-28 21:08
README.hpux
28.68
KB
-r--r--r--
2014-12-27 11:49
README.hurd
1.94
KB
-r--r--r--
2014-12-27 11:48
README.irix
4.29
KB
-r--r--r--
2014-12-27 11:48
README.jp
7.34
KB
-r--r--r--
2014-12-27 11:48
README.ko
11.97
KB
-r--r--r--
2014-12-27 11:48
README.linux
1.45
KB
-r--r--r--
2014-12-27 11:48
README.macos
1001
B
-r--r--r--
2014-12-27 11:48
README.macosx
11.72
KB
-r--r--r--
2015-01-28 21:08
README.micro
1.81
KB
-r--r--r--
2014-12-27 11:48
README.netware
6.32
KB
-r--r--r--
2014-12-27 11:48
README.openbsd
1.18
KB
-r--r--r--
2014-12-27 11:48
README.os2
90.54
KB
-r--r--r--
2015-01-28 21:08
README.os390
15.19
KB
-r--r--r--
2014-12-27 11:48
README.os400
4.51
KB
-r--r--r--
2014-12-27 11:48
README.plan9
5
KB
-r--r--r--
2014-12-27 11:48
README.qnx
6.52
KB
-r--r--r--
2014-12-27 11:48
README.riscos
1.49
KB
-r--r--r--
2014-12-27 11:48
README.solaris
29.11
KB
-r--r--r--
2014-12-27 11:48
README.symbian
15.44
KB
-r--r--r--
2014-12-27 11:48
README.synology
6.88
KB
-r--r--r--
2014-12-27 11:48
README.tru64
7.56
KB
-r--r--r--
2014-12-27 11:49
README.tw
4.5
KB
-r--r--r--
2014-12-27 11:48
README.vms
23.45
KB
-r--r--r--
2015-01-28 21:08
README.vos
3.75
KB
-r--r--r--
2014-12-27 11:48
README.win32
37.59
KB
-r--r--r--
2015-01-15 22:12
TestInit.pm
2.95
KB
-r--r--r--
2014-12-27 11:49
XSUB.h
21.18
KB
-r--r--r--
2014-12-27 11:49
autodoc.pl
13.88
KB
-r--r--r--
2014-12-27 11:49
av.c
23.23
KB
-r--r--r--
2014-12-27 11:49
av.h
3.15
KB
-r--r--r--
2014-12-27 11:49
av.o
17.22
KB
-rw-r--r--
2016-10-10 17:36
bitcount.h
850
B
-rw-r--r--
2016-10-10 17:36
caretx.c
4.14
KB
-r--r--r--
2014-12-27 11:49
caretx.o
2.1
KB
-rw-r--r--
2016-10-10 17:36
cflags
3.79
KB
-rwxr-xr-x
2016-10-10 17:34
cflags.SH
10.3
KB
-r-xr-xr-x
2014-12-27 11:49
charclass_invlists.h
86.63
KB
-r--r--r--
2014-12-27 11:49
config.h
144.21
KB
-rw-r--r--
2016-10-10 17:34
config.sh
33.79
KB
-rw-r--r--
2016-10-10 17:34
config_h.SH
147.66
KB
-r-xr-xr-x
2014-12-27 11:49
configpm
31.32
KB
-r-xr-xr-x
2014-12-27 11:49
configure.com
211.66
KB
-r--r--r--
2014-12-27 11:49
configure.gnu
2.5
KB
-r-xr-xr-x
2014-12-27 11:48
cop.h
40.55
KB
-r--r--r--
2014-12-27 11:49
cv.h
10.25
KB
-r--r--r--
2014-12-27 11:49
deb.c
7.48
KB
-r--r--r--
2014-12-27 11:49
deb.o
2.15
KB
-rw-r--r--
2016-10-10 17:36
doio.c
64.64
KB
-r--r--r--
2014-12-27 11:49
doio.o
54.52
KB
-rw-r--r--
2016-10-10 17:36
doop.c
29.36
KB
-r--r--r--
2014-12-27 11:49
doop.o
23.63
KB
-rw-r--r--
2016-10-10 17:36
dosish.h
5.41
KB
-r--r--r--
2014-12-27 11:48
dquote_static.c
10.92
KB
-r--r--r--
2014-12-27 11:49
dump.c
99.94
KB
-r--r--r--
2015-01-12 22:02
dump.o
75.78
KB
-rw-r--r--
2016-10-10 17:36
embed.fnc
114
KB
-r--r--r--
2014-12-27 11:49
embed.h
88.24
KB
-rw-r--r--
2014-12-27 11:49
embedvar.h
17.51
KB
-rw-r--r--
2014-12-27 11:49
ext.libs
0
B
-rw-r--r--
2016-10-10 17:38
extra.pods
585
B
-rw-r--r--
2016-10-10 17:36
fakesdio.h
3.24
KB
-r--r--r--
2014-12-27 11:48
feature.h
4.26
KB
-rw-r--r--
2014-12-27 11:49
form.h
1.43
KB
-r--r--r--
2014-12-27 11:48
generate_uudmap
14.41
KB
-rwxr-xr-x
2016-10-10 17:36
generate_uudmap.c
3.73
KB
-r--r--r--
2014-12-27 11:49
generate_uudmap.o
10.16
KB
-rw-r--r--
2016-10-10 17:36
git_version.h
357
B
-rw-r--r--
2016-10-10 17:36
globals.c
1.28
KB
-r--r--r--
2014-12-27 11:48
globals.o
96.84
KB
-rw-r--r--
2016-10-10 17:36
globvar.sym
994
B
-r--r--r--
2014-12-27 11:49
gv.c
99.2
KB
-r--r--r--
2014-12-27 12:19
gv.h
10.54
KB
-r--r--r--
2014-12-27 11:49
gv.o
82.3
KB
-rw-r--r--
2016-10-10 17:35
handy.h
90.96
KB
-r--r--r--
2014-12-27 11:49
hv.c
102.94
KB
-r--r--r--
2014-12-27 11:49
hv.h
23.9
KB
-r--r--r--
2014-12-27 11:48
hv.o
43.42
KB
-rw-r--r--
2016-10-10 17:36
hv_func.h
17.45
KB
-r--r--r--
2014-12-27 11:49
inline.h
9.29
KB
-r--r--r--
2014-12-27 11:49
inline_invlist.c
1.91
KB
-r--r--r--
2014-12-27 11:49
install_lib.pl
3.9
KB
-r--r--r--
2014-12-27 11:49
installhtml
17.04
KB
-r--r--r--
2014-12-27 11:48
installman
5.62
KB
-r-xr-xr-x
2014-12-27 11:48
installperl
27.46
KB
-r-xr-xr-x
2015-01-10 12:06
intrpvar.h
26.99
KB
-r--r--r--
2015-01-28 21:08
iperlsys.h
47.63
KB
-r--r--r--
2014-12-27 11:49
keywords.c
88.86
KB
-rw-r--r--
2014-12-27 11:49
keywords.h
6.43
KB
-rw-r--r--
2014-12-27 11:49
keywords.o
30.68
KB
-rw-r--r--
2016-10-10 17:36
l1_char_class_tab.h
38.25
KB
-r--r--r--
2014-12-27 11:49
libperl.a
2.75
MB
-rw-r--r--
2016-10-10 17:38
locale.c
45.02
KB
-r--r--r--
2014-12-27 11:49
locale.o
15.68
KB
-rw-r--r--
2016-10-10 17:36
madly.c
704
B
-r--r--r--
2014-12-27 11:49
make_ext.pl
24.34
KB
-r--r--r--
2015-01-10 12:06
make_patchnum.pl
6.65
KB
-r--r--r--
2014-12-27 11:49
makedef.pl
33.97
KB
-r--r--r--
2015-01-12 20:14
makedepend
7.07
KB
-rwxr-xr-x
2016-10-10 17:34
makedepend.SH
7.82
KB
-r-xr-xr-x
2014-12-27 11:49
makefile
303.73
KB
-rw-r--r--
2016-10-10 17:34
makefile.old
34.77
KB
-rw-r--r--
2016-10-10 17:34
malloc.c
70.51
KB
-r--r--r--
2014-12-27 11:49
malloc_ctl.h
1.48
KB
-r--r--r--
2014-12-27 11:48
mathoms.c
30.41
KB
-r--r--r--
2014-12-27 11:49
mathoms.o
30.02
KB
-rw-r--r--
2016-10-10 17:36
metaconfig.SH
1.18
KB
-r-xr-xr-x
2014-12-27 11:48
metaconfig.h
981
B
-r--r--r--
2014-12-27 11:49
mg.c
84.07
KB
-r--r--r--
2014-12-27 12:31
mg.h
2.9
KB
-r--r--r--
2014-12-27 11:49
mg.o
72.97
KB
-rw-r--r--
2016-10-10 17:36
mg_data.h
4.7
KB
-rw-r--r--
2016-10-10 17:36
mg_names.c
2.05
KB
-r--r--r--
2014-12-27 11:49
mg_raw.h
4.02
KB
-r--r--r--
2014-12-27 11:49
mg_vtable.h
8.73
KB
-rw-r--r--
2014-12-27 11:49
miniperl
1.53
MB
-rwxr-xr-x
2016-10-10 17:36
miniperlmain.c
5.11
KB
-r--r--r--
2014-12-27 11:49
miniperlmain.o
2.95
KB
-rw-r--r--
2016-10-10 17:35
mkppport
4.26
KB
-r--r--r--
2014-12-27 11:48
mkppport.lst
257
B
-r--r--r--
2014-12-27 11:48
mro.c
42.78
KB
-r--r--r--
2014-12-27 11:49
mro.o
24.22
KB
-rw-r--r--
2016-10-10 17:36
myconfig
2
KB
-rwxr-xr-x
2016-10-10 17:34
myconfig.SH
2.45
KB
-r-xr-xr-x
2014-12-27 11:49
mydtrace.h
2.83
KB
-r--r--r--
2014-12-27 11:48
nostdio.h
3.37
KB
-r--r--r--
2014-12-27 11:49
numeric.c
33.86
KB
-r--r--r--
2014-12-27 11:49
numeric.o
14.3
KB
-rw-r--r--
2016-10-10 17:36
op.c
339.8
KB
-r--r--r--
2015-01-12 22:02
op.h
37.45
KB
-r--r--r--
2014-12-27 12:38
op.o
218.2
KB
-rw-r--r--
2016-10-10 17:38
op_reg_common.h
5.08
KB
-r--r--r--
2014-12-27 11:49
opcode.h
46.78
KB
-rw-r--r--
2014-12-27 11:49
opmini.c
339.8
KB
-r--r--r--
2015-01-12 22:02
opmini.o
217.94
KB
-rw-r--r--
2016-10-10 17:35
opnames.h
8.17
KB
-rw-r--r--
2014-12-27 11:49
overload.c
3.32
KB
-rw-r--r--
2014-12-27 11:48
overload.h
2.95
KB
-rw-r--r--
2014-12-27 11:48
packsizetables.c
5.94
KB
-r--r--r--
2014-12-27 11:48
pad.c
71.56
KB
-r--r--r--
2015-01-15 22:12
pad.h
15.99
KB
-r--r--r--
2015-01-15 22:12
pad.o
31.54
KB
-rw-r--r--
2016-10-10 17:36
parser.h
6.52
KB
-r--r--r--
2014-12-27 11:49
patchlevel.h
5.19
KB
-r--r--r--
2015-02-01 03:22
perl
1.63
MB
-rwxr-xr-x
2016-10-10 19:19
perl.c
131.72
KB
-r--r--r--
2015-01-28 21:12
perl.h
177.1
KB
-r--r--r--
2015-01-12 20:14
perl.o
175.37
KB
-rw-r--r--
2016-10-10 17:38
perlapi.c
1.69
KB
-rw-r--r--
2014-12-27 11:48
perlapi.h
5.49
KB
-rw-r--r--
2014-12-27 11:48
perlapi.o
939
B
-rw-r--r--
2016-10-10 17:36
perldtrace.d
563
B
-r--r--r--
2014-12-27 11:48
perlio.c
117.77
KB
-r--r--r--
2014-12-27 11:49
perlio.h
10.22
KB
-r--r--r--
2014-12-27 11:48
perlio.o
72.05
KB
-rw-r--r--
2016-10-10 17:36
perlio.sym
446
B
-r--r--r--
2014-12-27 11:48
perliol.h
13.32
KB
-r--r--r--
2014-12-27 11:49
perlmain.c
5.09
KB
-rw-r--r--
2016-10-10 19:19
perlmain.o
3.38
KB
-rw-r--r--
2016-10-10 19:19
perlmini.c
131.72
KB
-r--r--r--
2015-01-28 21:12
perlmini.o
173.31
KB
-rw-r--r--
2016-10-10 17:35
perlsdio.h
4.92
KB
-r--r--r--
2014-12-27 11:48
perlvars.h
8.76
KB
-r--r--r--
2014-12-27 11:48
perly.act
55.04
KB
-r--r--r--
2014-12-27 11:49
perly.c
16.1
KB
-r--r--r--
2014-12-27 11:49
perly.h
6.08
KB
-r--r--r--
2014-12-27 11:49
perly.o
51.13
KB
-rw-r--r--
2016-10-10 17:36
perly.tab
74.01
KB
-r--r--r--
2014-12-27 11:49
perly.y
38.93
KB
-r--r--r--
2014-12-27 11:49
pp.c
147.83
KB
-r--r--r--
2014-12-27 11:49
pp.h
19.83
KB
-r--r--r--
2014-12-27 11:49
pp.o
150.74
KB
-rw-r--r--
2016-10-10 17:36
pp_ctl.c
142.43
KB
-r--r--r--
2015-01-24 15:03
pp_ctl.o
143.59
KB
-rw-r--r--
2016-10-10 17:36
pp_hot.c
82.79
KB
-r--r--r--
2014-12-27 11:49
pp_hot.o
76.93
KB
-rw-r--r--
2016-10-10 17:36
pp_pack.c
81.07
KB
-r--r--r--
2014-12-27 11:49
pp_pack.o
78.95
KB
-rw-r--r--
2016-10-10 17:36
pp_proto.h
10.81
KB
-rw-r--r--
2014-12-27 11:49
pp_sort.c
64.99
KB
-r--r--r--
2014-12-27 11:49
pp_sort.o
25.86
KB
-rw-r--r--
2016-10-10 17:36
pp_sys.c
128.85
KB
-r--r--r--
2015-01-11 14:03
pp_sys.o
145.77
KB
-rw-r--r--
2016-10-10 17:36
proto.h
275.69
KB
-rw-r--r--
2014-12-27 11:49
realclean.sh
46.47
KB
-rw-r--r--
2016-10-10 19:19
reentr.c
15.59
KB
-rw-r--r--
2014-12-27 11:49
reentr.h
76.44
KB
-rw-r--r--
2014-12-27 11:49
reentr.o
1.52
KB
-rw-r--r--
2016-10-10 17:36
regcharclass.h
52.42
KB
-rw-r--r--
2014-12-27 11:49
regcomp.c
610.17
KB
-r--r--r--
2015-01-10 13:15
regcomp.h
37.6
KB
-r--r--r--
2014-12-27 11:49
regcomp.o
220.61
KB
-rw-r--r--
2016-10-10 17:36
regcomp.sym
11.89
KB
-r--r--r--
2014-12-27 11:49
regen.pl
862
B
-r--r--r--
2014-12-27 11:49
regen_perly.pl
9
KB
-r--r--r--
2014-12-27 11:49
regexec.c
291.97
KB
-r--r--r--
2014-12-27 11:49
regexec.o
109.56
KB
-rw-r--r--
2016-10-10 17:36
regexp.h
31.38
KB
-r--r--r--
2014-12-27 11:49
regnodes.h
34.54
KB
-rw-r--r--
2014-12-27 11:49
run.c
1.53
KB
-r--r--r--
2014-12-27 11:49
run.o
1.59
KB
-rw-r--r--
2016-10-10 17:36
runtests
1.09
KB
-rwxr-xr-x
2016-10-10 17:34
runtests.SH
1.79
KB
-r-xr-xr-x
2014-12-27 11:49
scope.c
36.35
KB
-r--r--r--
2014-12-27 11:49
scope.h
11.64
KB
-r--r--r--
2014-12-27 11:49
scope.o
29.58
KB
-rw-r--r--
2016-10-10 17:36
sv.c
408.23
KB
-r--r--r--
2015-01-15 22:12
sv.h
80.16
KB
-r--r--r--
2015-01-15 22:12
sv.o
166.73
KB
-rw-r--r--
2016-10-10 17:36
taint.c
4.91
KB
-r--r--r--
2014-12-27 11:49
taint.o
5.8
KB
-rw-r--r--
2016-10-10 17:36
thread.h
11.53
KB
-r--r--r--
2014-12-27 11:49
time64.c
15.29
KB
-r--r--r--
2014-12-27 11:49
time64.h
1.57
KB
-r--r--r--
2014-12-27 11:49
time64_config.h
1.98
KB
-r--r--r--
2014-12-27 11:49
toke.c
350.24
KB
-r--r--r--
2015-01-24 15:03
toke.o
274.02
KB
-rw-r--r--
2016-10-10 17:36
uconfig.h
144.22
KB
-rw-r--r--
2014-12-27 11:49
uconfig.sh
15.69
KB
-r--r--r--
2014-12-27 11:49
uconfig64.sh
15.73
KB
-r--r--r--
2014-12-27 11:49
unicode_constants.h
2.12
KB
-r--r--r--
2014-12-27 11:49
universal.c
24.91
KB
-r--r--r--
2014-12-27 11:49
universal.o
45.73
KB
-rw-r--r--
2016-10-10 17:36
unixish.h
4.48
KB
-r--r--r--
2014-12-27 11:49
utf8.c
135.85
KB
-r--r--r--
2014-12-27 12:10
utf8.h
29.3
KB
-r--r--r--
2014-12-27 11:49
utf8.o
77.52
KB
-rw-r--r--
2016-10-10 17:36
utfebcdic.h
45.12
KB
-r--r--r--
2014-12-27 11:49
util.c
138.18
KB
-r--r--r--
2014-12-27 12:20
util.h
2.53
KB
-r--r--r--
2014-12-27 11:49
util.o
70.16
KB
-rw-r--r--
2016-10-10 17:36
utils.lst
623
B
-r--r--r--
2014-12-27 11:49
uudmap.h
904
B
-rw-r--r--
2016-10-10 17:36
veryclean.sh
46.47
KB
-rw-r--r--
2016-10-10 19:19
vutil.c
25.44
KB
-r--r--r--
2014-12-27 11:49
vutil.h
7.06
KB
-r--r--r--
2014-12-27 11:49
vxs.inc
10.91
KB
-r--r--r--
2014-12-27 11:49
warnings.h
4.94
KB
-rw-r--r--
2014-12-27 11:49
write_buildcustomize.pl
3.01
KB
-r--r--r--
2014-12-27 11:49
Save
Rename
#!/usr/bin/perl # These two should go upon release to make the script Perl 5.005 compatible use strict; use warnings; =head1 NAME make_patchnum.pl - make patchnum =head1 SYNOPSIS miniperl make_patchnum.pl perl make_patchnum.pl =head1 DESCRIPTION This program creates the files holding the information about locally applied patches to the source code. The created files are F<git_version.h> and F<lib/Config_git.pl>. =head2 F<lib/Config_git.pl> Contains status information from git in a form meant to be processed by the tied hash logic of Config.pm. It is actually optional, although -V:git.\* will be uninformative without it. C<git_version.h> contains similar information in a C header file format, designed to be used by patchlevel.h. This file is obtained from stock_git_version.h if miniperl is not available, and then later on replaced by the version created by this script. =head1 AUTHOR Yves Orton, Kenichi Ishigaki, Max Maischein =head1 COPYRIGHT Same terms as Perl itself. =cut # from a -Dmksymlink target dir, I need to cd to the git-src tree to # use git (like script does). Presuming that's not unique, one fix is # to follow Configure's symlink-path to run git. Maybe GIT_DIR or # path-args can solve it, if so we should advise here, I tried only # very briefly ('cd -' works too). my ($subcd, $srcdir); our $opt_v = scalar grep $_ eq '-v', @ARGV; BEGIN { my $root="."; # test 1st to see if we're a -Dmksymlinks target dir $subcd = ''; $srcdir = $root; if (-l "./Configure") { $srcdir = readlink("./Configure"); $srcdir =~ s/Configure//; $subcd = "cd $srcdir &&"; # activate backtick fragment } while (!-e "$root/perl.c" and length($root)<100) { if ($root eq '.') { $root=".."; } else { $root.="/.."; } } die "Can't find toplevel" if !-e "$root/perl.c"; sub path_to { "$root/$_[0]" } # use $_[0] if this'd be placed in toplevel. } sub read_file { my $file = path_to(@_); return "" unless -e $file; open my $fh, '<', $file or die "Failed to open for read '$file':$!"; return do { local $/; <$fh> }; } sub write_file { my ($file, $content) = @_; $file= path_to($file); open my $fh, '>', $file or die "Failed to open for write '$file':$!"; print $fh $content; close $fh; } sub backtick { # only for git. If we're in a -Dmksymlinks build-dir, we need to # cd to src so git will work . Probably a better way. my $command = shift; if (wantarray) { my @result= `$subcd $command`; #warn "$subcd $command: \$?=$?\n" if $?; print "#> $subcd $command ->\n @result\n" if !$? and $opt_v; chomp @result; return @result; } else { my $result= `$subcd $command`; $result="" if ! defined $result; warn "$subcd $command: \$?=$?\n" if $?; print "#> $subcd $command ->\n $result\n" if !$? and $opt_v; chomp $result; return $result; } } sub write_files { my %content= map { /WARNING: '([^']+)'/ || die "Bad mojo!"; $1 => $_ } @_; my @files= sort keys %content; my $files= join " and ", map { "'$_'" } @files; foreach my $file (@files) { if (read_file($file) ne $content{$file}) { print "Updating $files\n"; write_file($_,$content{$_}) for @files; return 1; } } print "Reusing $files\n"; return 0; } my $unpushed_commits = ' '; my ($read, $branch, $snapshot_created, $commit_id, $describe)= ("") x 5; my ($changed, $extra_info, $commit_title)= ("") x 3; if (my $patch_file= read_file(".patch")) { ($branch, $snapshot_created, $commit_id, $describe) = split /\s+/, $patch_file; $extra_info = "git_snapshot_date='$snapshot_created'"; $commit_title = "Snapshot of:"; } elsif (-d "$srcdir/.git") { # git branch | awk 'BEGIN{ORS=""} /\*/ { print $2 }' ($branch) = map { /\* ([^(]\S*)/ ? $1 : () } backtick("git branch"); $branch //= ""; my ($remote,$merge); if (length $branch) { $merge= backtick("git config branch.$branch.merge"); $merge = "" unless $? == 0; $merge =~ s!^refs/heads/!!; $remote= backtick("git config branch.$branch.remote"); $remote = "" unless $? == 0; } $commit_id = backtick("git rev-parse HEAD"); $describe = backtick("git describe"); my $commit_created = backtick(qq{git log -1 --pretty="format:%ci"}); $extra_info = "git_commit_date='$commit_created'"; backtick("git diff --no-ext-diff --quiet --exit-code"); $changed = $?; unless ($changed) { backtick("git diff-index --cached --quiet HEAD --"); $changed = $?; } if (length $branch && length $remote) { # git cherry $remote/$branch | awk 'BEGIN{ORS=","} /\+/ {print $2}' | sed -e 's/,$//' my $unpushed_commit_list = join ",", map { (split /\s/, $_)[1] } grep {/\+/} backtick("git cherry $remote/$merge"); # git cherry $remote/$branch | awk 'BEGIN{ORS="\t\\\\\n"} /\+/ {print ",\"" $2 "\""}' $unpushed_commits = join "", map { ',"'.(split /\s/, $_)[1]."\"\t\\\n" } grep {/\+/} backtick("git cherry $remote/$merge"); if (length $unpushed_commits) { $commit_title = "Local Commit:"; my $ancestor = backtick("git rev-parse $remote/$merge"); $extra_info = "$extra_info git_ancestor='$ancestor' git_remote_branch='$remote/$merge' git_unpushed='$unpushed_commit_list'"; } } if ($changed) { $commit_title = "Derived from:"; } $commit_title ||= "Commit id:"; } # we extract the filename out of the warning header, so don't mess with that write_files(<<"EOF_HEADER", <<"EOF_CONFIG"); /************************************************************************** * WARNING: 'git_version.h' is automatically generated by make_patchnum.pl * DO NOT EDIT DIRECTLY - edit make_patchnum.pl instead ***************************************************************************/ @{[$describe ? "#define PERL_PATCHNUM \"$describe\"" : ()]} #define PERL_GIT_UNPUSHED_COMMITS\t\t\\ $unpushed_commits/*leave-this-comment*/ @{[$changed ? "#define PERL_GIT_UNCOMMITTED_CHANGES" : ()]} EOF_HEADER ###################################################################### # WARNING: 'lib/Config_git.pl' is generated by make_patchnum.pl # DO NOT EDIT DIRECTLY - edit make_patchnum.pl instead ###################################################################### \$Config::Git_Data=<<'ENDOFGIT'; git_commit_id='$commit_id' git_describe='$describe' git_branch='$branch' git_uncommitted_changes='$changed' git_commit_id_title='$commit_title' $extra_info ENDOFGIT EOF_CONFIG # ex: set ts=8 sts=4 sw=4 et ft=perl: